package cs636.music.presentation.web;

import java.math.BigDecimal;

/**
 * CartItemData: model object for item in the cart, i.e., it's used
 * to carry data from the controller to the JSP
 *
 */
public class CartItemDetails {

	private int quantity;
	private String code;
	private String description;
	private BigDecimal price;  // using BigDecimal to preserve exact pennies
		
	public CartItemDetails (String code, int quantity, String description, BigDecimal price) {
		this.code = code;
		this.quantity = quantity;
		this.description = description;
		this.price = price;
	}

	public int getQuantity() {
		return quantity;
	}
	
	public String getDescription() {
		return description;
	}

	public String getCode() {
		return code;
	}

	public BigDecimal getPrice() {
		return price;
	}

}
